import { Metadata } from '../metadataGeneration/metadataGenerator';
import { Swagger } from './swagger';
export interface Options {
    host: string;
    name: string;
    version: string;
    description: string;
    basePath: string;
    license: string;
}
export declare class SpecGenerator {
    private readonly metadata;
    private readonly options;
    constructor(metadata: Metadata, options: Options);
    GenerateJson(swaggerDir: string): void;
    GetSpec(): Swagger.Spec;
    private buildDefinitions();
    private buildPaths();
    private buildPathMethod(method, pathObject);
    private buildParameter(parameter);
    private buildProperties(properties);
    private getSwaggerType(type);
    private getSwaggerTypeForPrimitiveType(primitiveTypeName);
    private getSwaggerTypeForArrayType(arrayType);
    private getSwaggerTypeForReferenceType(referenceType);
    private get200Operation(swaggerType, example, methodName);
    private get204Operation(methodName);
}
