"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const example_1 = require('../../../src/decorators/example');
const methods_1 = require('../../../src/decorators/methods');
const modelService_1 = require('../services/modelService');
const route_1 = require('../../../src/decorators/route');
let GetTestController = class GetTestController {
    /**
     * This is a description of the getModel method
     * this is some more text on another line
     */
    getModel() {
        return __awaiter(this, void 0, void 0, function* () {
            return new modelService_1.ModelService().getModel();
        });
    }
    getCurrentModel() {
        return __awaiter(this, void 0, void 0, function* () {
            return new modelService_1.ModelService().getModel();
        });
    }
    getMultipleModels() {
        return __awaiter(this, void 0, void 0, function* () {
            return [
                new modelService_1.ModelService().getModel(),
                new modelService_1.ModelService().getModel(),
                new modelService_1.ModelService().getModel()
            ];
        });
    }
    /**
     * @param numberPathParam This is a description for numberPathParam
     * @param numberParam This is a description for numberParam
     */
    getModelByParams(numberPathParam, stringPathParam, booleanPathParam, booleanParam, stringParam, numberParam, optionalStringParam) {
        return __awaiter(this, void 0, void 0, function* () {
            const model = new modelService_1.ModelService().getModel();
            model.optionalString = optionalStringParam;
            model.numberValue = numberPathParam;
            model.boolValue = booleanPathParam;
            model.stringValue = stringPathParam;
            return model;
        });
    }
    getResponseWithUnionTypeProperty() {
        return __awaiter(this, void 0, void 0, function* () {
            return {
                value: 'success'
            };
        });
    }
    getUnionTypeResponse() {
        return __awaiter(this, void 0, void 0, function* () {
            return '';
        });
    }
};
__decorate([
    methods_1.Get(),
    example_1.Example({
        boolArray: [true, false],
        boolValue: true,
        id: 1,
        modelValue: {
            email: 'test@test.com',
            id: 100,
        },
        modelsArray: null,
        numberArray: [1, 2, 3],
        numberValue: 1,
        optionalString: 'optional string',
        stringArray: ['string one', 'string two'],
        stringValue: 'a string'
    })
], GetTestController.prototype, "getModel", null);
__decorate([
    methods_1.Get('Current')
], GetTestController.prototype, "getCurrentModel", null);
__decorate([
    methods_1.Get('Multi')
], GetTestController.prototype, "getMultipleModels", null);
__decorate([
    methods_1.Get('{numberPathParam}/{booleanPathParam}/{stringPathParam}')
], GetTestController.prototype, "getModelByParams", null);
__decorate([
    methods_1.Get('ResponseWithUnionTypeProperty')
], GetTestController.prototype, "getResponseWithUnionTypeProperty", null);
__decorate([
    methods_1.Get('UnionTypeResponse')
], GetTestController.prototype, "getUnionTypeResponse", null);
GetTestController = __decorate([
    route_1.Route('GetTest')
], GetTestController);
exports.GetTestController = GetTestController;
//# sourceMappingURL=getController.js.map