"use strict";
/**
 * THIS IS GENERATED CODE - DO NOT EDIT
 */
/* tslint:disable */
const templateHelpers_1 = require('../../src/routeGeneration/templateHelpers');
const putController_1 = require('./controllers/putController');
const postController_1 = require('./controllers/postController');
const patchController_1 = require('./controllers/patchController');
const getController_1 = require('./controllers/getController');
const deleteController_1 = require('./controllers/deleteController');
const models = {
    'TestSubModel': {
        'email': { typeName: 'string', required: true },
        'id': { typeName: 'number', required: true },
    },
    'TestModel': {
        'numberValue': { typeName: 'number', required: true },
        'numberArray': { typeName: 'array', required: true, arrayType: 'number' },
        'stringValue': { typeName: 'string', required: true },
        'stringArray': { typeName: 'array', required: true, arrayType: 'string' },
        'boolValue': { typeName: 'boolean', required: true },
        'boolArray': { typeName: 'array', required: true, arrayType: 'boolean' },
        'modelValue': { typeName: 'TestSubModel', required: true },
        'modelsArray': { typeName: 'array', required: true, arrayType: 'TestSubModel' },
        'dateValue': { typeName: 'datetime', required: false },
        'optionalString': { typeName: 'string', required: false },
        'id': { typeName: 'number', required: true },
    },
    'Result': {
        'value': { typeName: 'object', required: true },
    },
};
function RegisterRoutes(app) {
    app.put('/PutTest', function (req, res, next) {
        const params = {
            'model': { typeName: 'TestModel', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, 'model');
        }
        catch (err) {
            return next(err);
        }
        const controller = new putController_1.PutTestController();
        promiseHandler(controller.putModel.apply(controller, validatedParams), res, next);
    });
    app.put('/PutTest/Location', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new putController_1.PutTestController();
        promiseHandler(controller.putModelAtLocation.apply(controller, validatedParams), res, next);
    });
    app.put('/PutTest/Multi', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new putController_1.PutTestController();
        promiseHandler(controller.putWithMultiReturn.apply(controller, validatedParams), res, next);
    });
    app.put('/PutTest/WithId/:id', function (req, res, next) {
        const params = {
            'id': { typeName: 'number', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new putController_1.PutTestController();
        promiseHandler(controller.putWithId.apply(controller, validatedParams), res, next);
    });
    app.post('/PostTest', function (req, res, next) {
        const params = {
            'model': { typeName: 'TestModel', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, 'model');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.postModel.apply(controller, validatedParams), res, next);
    });
    app.patch('/PostTest', function (req, res, next) {
        const params = {
            'model': { typeName: 'TestModel', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, 'model');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.updateModel.apply(controller, validatedParams), res, next);
    });
    app.post('/PostTest/Location', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.postModelAtLocation.apply(controller, validatedParams), res, next);
    });
    app.post('/PostTest/Multi', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.postWithMultiReturn.apply(controller, validatedParams), res, next);
    });
    app.post('/PostTest/WithId/:id', function (req, res, next) {
        const params = {
            'id': { typeName: 'number', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.postWithId.apply(controller, validatedParams), res, next);
    });
    app.post('/PostTest/WithBodyAndQueryParams', function (req, res, next) {
        const params = {
            'model': { typeName: 'TestModel', required: true },
            'query': { typeName: 'string', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, 'model');
        }
        catch (err) {
            return next(err);
        }
        const controller = new postController_1.PostTestController();
        promiseHandler(controller.postWithBodyAndQueryParams.apply(controller, validatedParams), res, next);
    });
    app.patch('/PatchTest', function (req, res, next) {
        const params = {
            'model': { typeName: 'TestModel', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, 'model');
        }
        catch (err) {
            return next(err);
        }
        const controller = new patchController_1.PatchTestController();
        promiseHandler(controller.patchModel.apply(controller, validatedParams), res, next);
    });
    app.patch('/PatchTest/Location', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new patchController_1.PatchTestController();
        promiseHandler(controller.patchModelAtLocation.apply(controller, validatedParams), res, next);
    });
    app.patch('/PatchTest/Multi', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new patchController_1.PatchTestController();
        promiseHandler(controller.patchWithMultiReturn.apply(controller, validatedParams), res, next);
    });
    app.patch('/PatchTest/WithId/:id', function (req, res, next) {
        const params = {
            'id': { typeName: 'number', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new patchController_1.PatchTestController();
        promiseHandler(controller.patchWithId.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getModel.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest/Current', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getCurrentModel.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest/Multi', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getMultipleModels.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest/:numberPathParam/:booleanPathParam/:stringPathParam', function (req, res, next) {
        const params = {
            'numberPathParam': { typeName: 'number', required: true },
            'stringPathParam': { typeName: 'string', required: true },
            'booleanPathParam': { typeName: 'boolean', required: true },
            'booleanParam': { typeName: 'boolean', required: true },
            'stringParam': { typeName: 'string', required: true },
            'numberParam': { typeName: 'number', required: true },
            'optionalStringParam': { typeName: 'string', required: false },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getModelByParams.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest/ResponseWithUnionTypeProperty', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getResponseWithUnionTypeProperty.apply(controller, validatedParams), res, next);
    });
    app.get('/GetTest/UnionTypeResponse', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new getController_1.GetTestController();
        promiseHandler(controller.getUnionTypeResponse.apply(controller, validatedParams), res, next);
    });
    app.delete('/DeleteTest', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new deleteController_1.DeleteTestController();
        promiseHandler(controller.deleteWithReturnValue.apply(controller, validatedParams), res, next);
    });
    app.delete('/DeleteTest/Current', function (req, res, next) {
        const params = {};
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new deleteController_1.DeleteTestController();
        promiseHandler(controller.deleteCurrent.apply(controller, validatedParams), res, next);
    });
    app.delete('/DeleteTest/:numberPathParam/:booleanPathParam/:stringPathParam', function (req, res, next) {
        const params = {
            'numberPathParam': { typeName: 'number', required: true },
            'stringPathParam': { typeName: 'string', required: true },
            'booleanPathParam': { typeName: 'boolean', required: true },
            'booleanParam': { typeName: 'boolean', required: true },
            'stringParam': { typeName: 'string', required: true },
            'numberParam': { typeName: 'number', required: true },
        };
        let validatedParams = [];
        try {
            validatedParams = getValidatedParams(params, req, '');
        }
        catch (err) {
            return next(err);
        }
        const controller = new deleteController_1.DeleteTestController();
        promiseHandler(controller.getModelByParams.apply(controller, validatedParams), res, next);
    });
    function promiseHandler(promise, response, next) {
        return promise
            .then((data) => {
            if (data) {
                response.json(data);
            }
            else {
                response.status(204);
                response.end();
            }
        })
            .catch((error) => next(error));
    }
    function getRequestParams(request, bodyParamName) {
        const merged = {};
        if (bodyParamName) {
            merged[bodyParamName] = request.body;
        }
        for (let attrname in request.params) {
            merged[attrname] = request.params[attrname];
        }
        for (let attrname in request.query) {
            merged[attrname] = request.query[attrname];
        }
        return merged;
    }
    function getValidatedParams(params, request, bodyParamName) {
        const requestParams = getRequestParams(request, bodyParamName);
        return Object.keys(params).map(key => {
            return templateHelpers_1.ValidateParam(params[key], requestParams[key], models, key);
        });
    }
}
exports.RegisterRoutes = RegisterRoutes;
//# sourceMappingURL=routes.js.map