"use strict";
const methodOverride = require('method-override');
const express = require('express');
const bodyParser = require('body-parser');
require('./controllers/putController');
require('./controllers/postController');
require('./controllers/patchController');
require('./controllers/getController');
require('./controllers/deleteController');
const routes_1 = require('./routes');
exports.app = express();
exports.app.use(bodyParser.urlencoded({ extended: true }));
exports.app.use(bodyParser.json());
exports.app.use(methodOverride());
routes_1.RegisterRoutes(exports.app);
// It's important that this come after the main routes are registered
exports.app.use((err, req, res, next) => {
    res.status(err.status || 500).send(err.message || 'An error occurred during the request.');
});
exports.app.listen(3000);
//# sourceMappingURL=server.js.map