"use strict";
const metadataGenerator_1 = require('../../../src/metadataGeneration/metadataGenerator');
const specGenerator_1 = require('../../../src/swagger/specGenerator');
const defaultOptions_1 = require('../../fixtures/defaultOptions');
const chai = require('chai');
const expect = chai.expect;
describe('Schema details generation', () => {
    const metadata = new metadataGenerator_1.MetadataGenerator('./tests/fixtures/controllers/getController.ts').Generate();
    const spec = new specGenerator_1.SpecGenerator(metadata, defaultOptions_1.getDefaultOptions()).GetSpec();
    it('should set API name if provided', () => expect(spec.info.title).to.equal(defaultOptions_1.getDefaultOptions().name));
    it('should set API description if provided', () => expect(spec.info.description).to.equal(defaultOptions_1.getDefaultOptions().description));
    it('should set API version if provided', () => expect(spec.info.version).to.equal(defaultOptions_1.getDefaultOptions().version));
    it('should set API host if provided', () => expect(spec.host).to.equal(defaultOptions_1.getDefaultOptions().host));
    it('should set API host if provided', () => expect(spec.info.license.name).to.equal(defaultOptions_1.getDefaultOptions().license));
});
//# sourceMappingURL=schemaDetails.spec.js.map