"use strict";
const chai = require('chai');
const expect = chai.expect;
function VerifyPathableParameter(params, paramValue, paramType, paramIn) {
    const parameter = verifyParameter(params, paramValue, paramIn);
    expect(parameter.type).to.equal(paramType);
}
exports.VerifyPathableParameter = VerifyPathableParameter;
function VerifyBodyParameter(params, paramValue, paramType, paramIn) {
    const parameter = verifyParameter(params, paramValue, paramIn);
    expect(parameter.schema.$ref).to.equal(paramType);
}
exports.VerifyBodyParameter = VerifyBodyParameter;
function verifyParameter(params, paramValue, paramIn) {
    const parameter = params.filter(p => p.name === paramValue)[0];
    expect(parameter, `Path parameter '${paramValue}' wasn't generated.`).to.exist;
    expect(parameter.in).to.equal(paramIn);
    return parameter;
}
//# sourceMappingURL=verifyParameter.js.map