"use strict";
const chai = require('chai');
const expect = chai.expect;
exports.modelName = '#/definitions/TestModel';
function VerifyPath(spec, route, getOperation, isCollection, isNoContent) {
    const path = spec.paths[route];
    expect(path, `Path object for ${route} route wasn\'t generated.`).to.exist;
    const operation = getOperation(path);
    expect(operation, `Method for ${route} route wasn\'t generated.`).to.exist;
    expect(operation.responses, `Response object for ${route} route wasn\'t generated.`).to.exist;
    if (isNoContent) {
        const successResponse = operation.responses['204'];
        expect(successResponse, `204 response for ${route} route wasn\'t generated.`).to.exist;
        return path;
    }
    const successResponse = operation.responses['200'];
    expect(successResponse, `200 response for ${route} route wasn\'t generated.`).to.exist;
    expect(successResponse.schema, `Schema for 200 response ${route} route wasn\'t generated.`).to.exist;
    if (isCollection) {
        expect(successResponse.schema.type).to.equal('array');
        expect(successResponse.schema.items.$ref).to.equal(exports.modelName);
    }
    else {
        expect(successResponse.schema.$ref).to.equal(exports.modelName);
    }
    return path;
}
exports.VerifyPath = VerifyPath;
//# sourceMappingURL=verifyPath.js.map